archboot/usr/bin/archboot-update-installer.sh

198 lines
10 KiB
Bash
Raw Normal View History

#!/usr/bin/env bash
# created by Tobias Powalowski <tpowa@archlinux.org>
2022-03-21 22:25:15 +01:00
. /usr/lib/archboot/common.sh
2022-01-13 17:21:39 +01:00
_D_SCRIPTS=""
_L_COMPLETE=""
_L_INSTALL_COMPLETE=""
_G_RELEASE=""
_CONFIG="/etc/archboot/${_RUNNING_ARCH}-update_installer.conf"
2022-01-13 17:21:39 +01:00
_W_DIR="/archboot"
2022-03-07 22:47:42 +01:00
_INSTALLER_SOURCE="https://gitlab.archlinux.org/tpowa/archboot/-/raw/master"
2022-03-24 16:24:43 +01:00
_BIN_PATH="/usr/bin"
_LIB_PATH="/usr/lib/archboot"
_INST_PATH="/${_LIB_PATH}/installer"
2021-09-22 09:02:56 +02:00
2022-02-03 07:14:49 +01:00
kver() {
# get kernel version from installed kernel
[[ "${_RUNNING_ARCH}" == "x86_64" ]] && VMLINUZ="vmlinuz-linux"
[[ "${_RUNNING_ARCH}" == "aarch64" ]] && VMLINUZ="Image"
2022-02-03 07:14:49 +01:00
if [[ -f "${VMLINUZ}" ]]; then
offset=$(hexdump -s 526 -n 2 -e '"%0d"' "${VMLINUZ}")
read -r _HWKVER _ < <(dd if="/${VMLINUZ}" bs=1 count=127 skip=$(( offset + 0x200 )) 2>/dev/null)
2022-02-03 07:14:49 +01:00
fi
# fallback if no detectable kernel is installed
[[ "${_HWKVER}" == "" ]] && _HWKVER="$(uname -r)"
}
2021-09-22 09:02:56 +02:00
usage () {
2022-03-18 16:09:33 +01:00
echo "Update installer, launch latest environment or create latest image files:"
2022-03-18 14:25:36 +01:00
echo "-------------------------------------------------------------------------"
echo "PARAMETERS:"
echo " -u Update scripts: setup, quickinst, tz, km and helpers."
echo ""
echo "On fast internet connection (100Mbit) (approx. 5 minutes):"
echo " -latest Launch latest archboot environment (using kexec)."
echo " This operation needs at least 2.3 GB RAM."
2022-03-18 14:25:36 +01:00
echo ""
echo " -latest-install Launch latest archboot environment with downloaded"
echo " package cache (using kexec)."
echo " This operation needs at least 2.7 GB RAM."
2022-03-18 14:25:36 +01:00
echo ""
echo " -latest-image Generate latest image files in /archboot-release directory"
echo " This operation needs at least 4.6 GB RAM."
2022-03-18 14:25:36 +01:00
echo ""
echo " -h This message."
exit 0
2021-09-22 09:02:56 +02:00
}
[[ -z "${1}" ]] && usage
while [ $# -gt 0 ]; do
case ${1} in
2022-01-13 17:21:39 +01:00
-u|--u) _D_SCRIPTS="1" ;;
-latest|--latest) _L_COMPLETE="1" ;;
-latest-install|--latest-install) _L_INSTALL_COMPLETE="1";;
-latest-image|--latest-image) _G_RELEASE="1" ;;
2021-09-22 09:02:56 +02:00
-h|--h|?) usage ;;
*) usage ;;
esac
shift
done
if [[ ! "$(cat /etc/hostname)" == "archboot" ]]; then
echo "This script should only be run in booted archboot environment. Aborting..."
exit 1
fi
# Download latest setup and quickinst script from git repository
2022-01-13 17:21:39 +01:00
if [[ "${_D_SCRIPTS}" == "1" ]]; then
2021-10-06 17:49:16 +02:00
echo "Downloading latest km, tz, quickinst, setup and helpers..."
2022-03-24 16:24:43 +01:00
wget -q "${_INSTALLER_SOURCE}${_BIN_PATH}/archboot-quickinst.sh?inline=false" -O /usr/bin/quickinst >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_BIN_PATH}/archboot-setup.sh?inline=false" -O /usr/bin/setup >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_BIN_PATH}/archboot-km.sh?inline=false" -O /usr/bin/km >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_BIN_PATH}/archboot-tz.sh?inline=false" -O /usr/bin/tz >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_BIN_PATH}/archboot-${_RUNNING_ARCH}-create-container.sh?inline=false" -O "/usr/bin/archboot-${_RUNNING_ARCH}-create-container.sh" >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_BIN_PATH}/archboot-${_RUNNING_ARCH}-release.sh?inline=false" -O "/usr/bin/archboot-${_RUNNING_ARCH}-release.sh" >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_BIN_PATH}/archboot-binary-check.sh?inline=false" -O /usr/bin/archboot-binary-check.sh >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_BIN_PATH}/archboot-update-installer.sh?inline=false" -O /usr/bin/update-installer.sh >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_LIB_PATH}/common.sh?inline=false" -O "${_LIB_PATH}/common.sh" >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_LIB_PATH}/container.sh?inline=false" -O "${_LIB_PATH}/container.sh" >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_LIB_PATH}/release.sh?inline=false" -O "${_LIB_PATH}/release.sh" >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_LIB_PATH}/iso.sh?inline=false" -O "${_LIB_PATH}/iso.sh" >/dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/autoconfiguration.sh?inline=false" -O "${_INST_PATH}/autoconfiguration.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/autoprepare.sh?inline=false" -O "${_INST_PATH}/autoprepare.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/base.sh?inline=false" -O "${_INST_PATH}/base.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/blockdevices.sh?inline=false" -O "${_INST_PATH}/blockdevices.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/bootloader.sh?inline=false" -O "${_INST_PATH}/bootloader.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/btrfs.sh?inline=false" -O "${_INST_PATH}/btrfs.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/common.sh?inline=false" -O "${_INST_PATH}/common.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/configuration.sh?inline=false" -O "${_INST_PATH}/configuration.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/mountpoints.sh?inline=false" -O "${_INST_PATH}/mountpoints.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/network.sh?inline=false" -O "${_INST_PATH}/network.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/pacman.sh?inline=false" -O "${_INST_PATH}/pacman.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/partition.sh?inline=false" -O "${_INST_PATH}/partition.sh" > /dev/null 2>&1
wget -q "${_INSTALLER_SOURCE}${_INST_PATH}/storage.sh?inline=false" -O "${_INST_PATH}/storage.sh" > /dev/null 2>&1
2021-10-07 07:48:14 +02:00
echo "Finished: Downloading scripts done."
2021-10-08 10:04:39 +02:00
exit 0
2021-09-22 09:02:56 +02:00
fi
2021-10-08 10:04:39 +02:00
echo "Information: Logging is done on /dev/tty7 ..."
2021-09-22 09:02:56 +02:00
# Generate new environment and launch it with kexec
2022-01-13 17:21:39 +01:00
if [[ "${_L_COMPLETE}" == "1" || "${_L_INSTALL_COMPLETE}" == "1" ]]; then
if [[ -f /.update-installer ]]; then
2022-03-07 22:39:50 +01:00
echo "Aborting: update-installer.sh is already running on other tty ..."
echo "If you are absolutly sure it's not running, you need to remove /.update-installer"
exit 1
fi
touch /.update-installer
# remove everything not necessary
echo "Step 1/9: Removing not necessary files from / ..."
2022-02-02 22:33:01 +01:00
[[ -d "/usr/lib/firmware" ]] && rm -r "/usr/lib/firmware"
[[ -d "/usr/lib/modules" ]] && rm -r "/usr/lib/modules"
rm -f /usr/lib/{libicu*,libstdc++*}
_SHARE_DIRS="archboot efitools file grub hwdata kbd licenses lshw makepkg nmap nano openvpn pacman refind systemd tc usb_modeswitch vim zoneinfo"
2022-02-08 17:17:17 +01:00
for i in ${_SHARE_DIRS}; do
#shellcheck disable=SC2115
2022-02-02 22:06:37 +01:00
[[ -d "/usr/share/${i}" ]] && rm -r "/usr/share/${i}"
done
2022-03-21 10:57:49 +01:00
echo "Step 2/9: Waiting for gpg pacman keyring import to finish ..."
2022-03-21 11:19:03 +01:00
while pgrep -x gpg > /dev/null 2>&1; do
2022-03-18 14:02:45 +01:00
sleep 1
done
systemctl stop pacman-init.service
echo "Step 3/9: Generating archboot container in ${_W_DIR} ..."
echo " This will need some time ..."
2021-09-26 08:52:27 +02:00
# create container without package cache
if [[ "${_L_COMPLETE}" == "1" ]]; then
"archboot-${_RUNNING_ARCH}-create-container.sh" "${_W_DIR}" -cc -cp >/dev/tty7 2>&1 || exit 1
fi
2021-09-26 08:52:27 +02:00
# create container with package cache
2022-03-18 12:32:00 +01:00
if [[ -e /var/cache/pacman/pkg/archboot.db ]]; then
# offline mode, for testing purposes
2022-03-18 14:14:10 +01:00
# add the db too on reboot
2022-03-18 14:25:36 +01:00
install -D -m644 /var/cache/pacman/pkg/archboot.db /archboot/var/cache/pacman/pkg/archboot.db
if [[ "${_L_INSTALL_COMPLETE}" == "1" ]]; then
"archboot-${_RUNNING_ARCH}-create-container.sh" "${_W_DIR}" -cc --install-source=file:///var/cache/pacman/pkg >/dev/tty7 2>&1 || exit 1
fi
2022-03-18 12:32:00 +01:00
else
#online mode
if [[ "${_L_INSTALL_COMPLETE}" == "1" ]]; then
"archboot-${_RUNNING_ARCH}-create-container.sh" "${_W_DIR}" -cc >/dev/tty7 2>&1 || exit 1
mv "${_W_DIR}"/var/cache/pacman/pkg /var/cache/pacman/
fi
2022-01-08 09:39:59 +01:00
fi
echo "Step 4/9: Moving kernel ${VMLINUZ} to ${_W_DIR} ..."
kver
mv "${_W_DIR}"/boot/${VMLINUZ} "${_W_DIR}"/ || exit 1
echo "Step 5/9: Collect initramfs files in ${_W_DIR} ..."
echo " This will need some time ..."
# add fix for mkinitcpio 31, remove when 32 is released
cp "${_W_DIR}"/usr/share/archboot/patches/31-mkinitcpio.fixed "${_W_DIR}"/usr/bin/mkinitcpio
2022-03-21 22:28:08 +01:00
cp "${_W_DIR}"/usr/share/archboot/patches/31-initcpio.functions.fixed "${_W_DIR}"/usr/lib/initcpio/functions
# write initramfs to "${_W_DIR}"/tmp
systemd-nspawn -D "${_W_DIR}" /bin/bash -c "umount tmp;mkinitcpio -k ${_HWKVER} -c ${_CONFIG} -d /tmp" >/dev/tty7 2>&1 || exit 1
#mv "${_W_DIR}/tmp" /initrd || exit 1
echo "Step 6/9: Cleanup ${_W_DIR} ..."
find "${_W_DIR}"/. -mindepth 1 -maxdepth 1 ! -name 'tmp' ! -name "${VMLINUZ}" -exec rm -rf {} \;
echo "Step 7/9: Create initramfs initrd.img ..."
2022-02-03 09:25:48 +01:00
echo " This will need some time ..."
# move cache back to initramfs directory in online mode
if ! [[ -e /var/cache/pacman/pkg/archboot.db ]]; then
[[ "${_L_INSTALL_COMPLETE}" == "1" ]] && mv /var/cache/pacman/pkg ${_W_DIR}/tmp/var/cache/pacman/
fi
2022-02-03 10:36:40 +01:00
#from /usr/bin/mkinitpcio.conf
# compress image with zstd
cd "${_W_DIR}"/tmp || exit 1
find . -mindepth 1 -printf '%P\0' | sort -z |
LANG=C bsdtar --uid 0 --gid 0 --null -cnf - -T - |
LANG=C bsdtar --null -cf - --format=newc @- | zstd -T0 -10> "${_W_DIR}"/initrd.img
for i in $(find . -mindepth 1 -type f | sort); do
rm "${i}" >/dev/null 2>&1
done
while pgreg -x bsdtar >/dev/null 2>&1; do
sleep 1
done
echo "Step 8/9: Cleanup ${_W_DIR}/tmp ..."
rm -r "${_W_DIR}"/tmp
echo "Step 9/9: Loading files through kexec into kernel now ..."
# load kernel and initrds into running kernel in background mode!
kexec -f "${_W_DIR}"/${VMLINUZ} --initrd="${_W_DIR}"/initrd.img --reuse-cmdline&
sleep 1
# remove kernel and initrd to save RAM for kexec in background
rm "${_W_DIR}"/{initrd.img,${VMLINUZ}}
while pgreg -x kexec >/dev/null 2>&1; do
sleep 1
done
echo "Finished: Rebooting in a few seconds ..."
sleep 30
2021-09-22 09:02:56 +02:00
fi
2021-09-22 09:02:56 +02:00
# Generate new images
2022-01-13 17:21:39 +01:00
if [[ "${_G_RELEASE}" == "1" ]]; then
2022-01-21 11:54:13 +01:00
echo "Step 1/1: Generating new iso files now in ${_W_DIR} ..."
2021-10-07 07:22:05 +02:00
echo " This will need some time ..."
2022-01-21 11:54:13 +01:00
"archboot-${_RUNNING_ARCH}-release.sh" "${_W_DIR}" >/dev/tty7 2>&1 || exit 1
echo "Finished: New isofiles are located in ${_W_DIR}"
2021-09-22 09:02:56 +02:00
fi